#include <siostream.hpp>
#include <algorithm>
using std::size_t;
socket_ostream::socket_ostream() : std::ostream(), buffer(1024){}
circular_buffer::circular_buffer(size_t size) : m_data(size), m_begin(m_data.data(), size, 0), m_end(m_data.data(), size, 0){
	
}
circular_buffer::iterator::iterator(char* _source, size_t _period, size_t _offset):source(_source),period(_period), offset(_offset){
	
}
circular_buffer::const_iterator::const_iterator(const char* _source, size_t _period, size_t _offset):source(_source),period(_period), offset(_offset){
	
}
void circular_buffer::resize(size_t size){
	std::vector<char> newdata(size);
	size_t os = m_end - m_begin;
	if(size >= (m_begin - m_end))
		std::copy(m_begin, m_begin, newdata.begin());
	else
		std::copy(m_begin, m_begin + size, newdata.begin());
	std::swap(m_data, newdata);
	m_begin = iterator(m_data.data(),size,0);
	m_end = iterator(m_data.data(),size,os);
}
char& circular_buffer::iterator::operator*()const{
	return *(source + offset);
}
const char& circular_buffer::const_iterator::operator*()const {
	return *(source + offset);
}
circular_buffer::iterator& circular_buffer::iterator::operator++(){
	++offset;
	if(offset == size)offset = 0;
	return *this;
}
circular_buffer::const_iterator& circular_buffer::const_iterator::operator++(){
	
}
circular_buffer::iterator circular_buffer::iterator::operator+(size_t leap)const{
	
}

std::ptrdiff_t circular_buffer::iterator::operator-(const iterator& o)const{
	
}
std::ptrdiff_t circular_buffer::iterator::operator-(const const_iterator& o)const{
	
}
std::ptrdiff_t circular_buffer::const_iterator::operator-(const iterator& o)const{
	
}
std::ptrdiff_t circular_buffer::const_iterator::operator-(const const_iterator& o)const{
	
}
circular_buffer::const_iterator circular_buffer::const_iterator::operator+(size_t leap)const{
	
}
circular_buffer::iterator& circular_buffer::iterator::operator=(const circular_buffer::iterator& o){
	source = o.source;
	period = o.period;
	offset = o.offset;
}
circular_buffer::const_iterator& circular_buffer::const_iterator::operator=(const circular_buffer::const_iterator& o){
	source = o.source;
	period = o.period;
	offset = o.offset;
}
circular_buffer::iterator circular_buffer::begin(){
	
}
circular_buffer::const_iterator circular_buffer::begin() const{
	
}
circular_buffer::iterator circular_buffer::end(){
	
}
circular_buffer::const_iterator circular_buffer::end()const{
	
}
socket_ostream& socket_ostream::put(char_type c){
	
}
socket_ostream& socket_ostream::operator<<(char*){
	
}
socket_ostream& socket_ostream::operator<<(const std::string&){
	
}
socket_ostream& socket_ostream::operator<<(int){
	
}